# SLPI Threading Example
This project **requires the Hexagon SDK Cross-Compiler Environment** available at voxl-docker (https://gitlab.com/voxl-public/voxl-docker).

1. Build sDSP/SLPI libraries and APP processor binary
```bash
$ cd helloworld
$ voxl-docker -i voxl-hexagon
$ ./build.sh
```

2. Confirm that target is found with adb
```bash
> adb devices
List of devices attached
1a2b3c4d	device
```

3. Push binaries and libraries to target
```bash
$ ./deploy_to_target
```

4. To view output from the DSP run Hexagon debug tool mini-dm (within voxl-hexagon docker image)
```bash
$ ${HEXAGON_SDK_ROOT}/tools/debug/mini-dm/Linux_Debug/mini-dm
```

5. In a new shell run example on target
```bash
$ adb shell
$ cd home/root
$ ./hello_threads
```

You should see the following output in the terminal running mini-dm:
```
Running mini-dm version: 3.1
<various initialization outputs>
DMSS is connected. Running mini-dm...
----------------Mini-dm is ready to log----------------
<warnings you can ignore>
[08500/00]  --:--.---  Hello World  0053  hello_threads.c
[08500/00]  --:--.---  New thread creation was successful  0080  hello_threads.c
[08500/00]  --:--.---  Hello from inside the new thread  0044  hello_threads.c
[08500/00]  --:--.---  Exiting the new thread  0046  hello_threads.c
[08500/00]  --:--.---  New thread finished  0090  hello_threads.c
[08500/00]  --:--.---  Bye bye :)  0092  hello_threads.c
```
